/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse prosparse
#define yylex   proslex
#define yyerror proserror
#define yylval  proslval
#define yychar  proschar
#define yydebug prosdebug
#define yynerrs prosnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     INT = 258,
     REAL = 259,
     STRING = 260,
     HOUR = 261,
     MINUTE = 262,
     SECOND = 263,
     DEGREE = 264,
     ARCMINUTE = 265,
     ARCSECOND = 266,
     RADIAN = 267,
     SEXSTR = 268,
     ANNULUS_ = 269,
     B1950_ = 270,
     BOX_ = 271,
     CIRCLE_ = 272,
     DEBUG_ = 273,
     ECLIPTIC_ = 274,
     ELLIPSE_ = 275,
     EQUATORIAL_ = 276,
     GALACTIC_ = 277,
     J2000_ = 278,
     LOGICAL_ = 279,
     N_ = 280,
     OFF_ = 281,
     ON_ = 282,
     PHYSICAL_ = 283,
     POINT_ = 284,
     POLYGON_ = 285,
     ROTBOX_ = 286,
     VERSION_ = 287
   };
#endif
#define INT 258
#define REAL 259
#define STRING 260
#define HOUR 261
#define MINUTE 262
#define SECOND 263
#define DEGREE 264
#define ARCMINUTE 265
#define ARCSECOND 266
#define RADIAN 267
#define SEXSTR 268
#define ANNULUS_ 269
#define B1950_ 270
#define BOX_ 271
#define CIRCLE_ 272
#define DEBUG_ 273
#define ECLIPTIC_ 274
#define ELLIPSE_ 275
#define EQUATORIAL_ 276
#define GALACTIC_ 277
#define J2000_ 278
#define LOGICAL_ 279
#define N_ 280
#define OFF_ 281
#define ON_ 282
#define PHYSICAL_ 283
#define POINT_ 284
#define POLYGON_ 285
#define ROTBOX_ 286
#define VERSION_ 287




/* Copy the first part of user declarations.  */
#line 5 "prosparser.Y"

#define YYPARSE_PARAM fr
#define YYDEBUG 1

#define FR ((FrameBase*)fr)
#define FITPTR (FR->findFits(1))

#define DISCARD_(x) {yyclearin; prosDiscard(x);}

#include <math.h>
#include <string.h>
#include <iostream.h>

#include "framebase.h"
#include "fitsimage.h"
#include "util.h"
#include "vector.h"
#include "list.h"
#include "basemarker.h"
#include "coord.h"

extern int proslex(void);
extern void proserror(const char*);
extern void prosDiscard(int);

int prossign;
int prossign2;

static CoordSystem globalSystem;
static SkyFrame globalSky;
static CoordSystem localSystem;
static SkyFrame localSky;

static unsigned short globalProps;
static unsigned short localProps;

static char *color = "green";
static char *font = "helvetica 10 normal";
static char *text = "";

static char localComment[80];

static List<Vertex> polylist;
static List<Tag> taglist;

static double aAnnuli[MAXANNULI];
static Vector aVector[MAXANNULI];
static int aNum;
static int aStatus;
static Vector aCenter;
static double aAngle;
static unsigned short aProps;
static char aComment[80];

static void setProps(unsigned short* props, unsigned short prop, int value);
static CoordSystem checkWCSSystem();
static SkyFrame checkWCSSky();


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 64 "prosparser.Y"
typedef union YYSTYPE {
  double real;
  int integer;
  char str[256];
  double vector[3];
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 214 "prosparser.C"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 226 "prosparser.C"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   228

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  44
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  41
/* YYNRULES -- Number of rules. */
#define YYNRULES  89
/* YYNRULES -- Number of states. */
#define YYNSTATES  194

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   287

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      33,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    42,     2,    43,     2,     2,    41,     2,
      36,    37,     2,    39,    35,    40,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    34,
       2,    38,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     7,    11,    14,    15,    18,    20,    21,
      25,    26,    30,    34,    36,    38,    40,    42,    44,    46,
      48,    49,    51,    52,    54,    55,    57,    58,    60,    62,
      64,    66,    68,    70,    72,    74,    78,    82,    86,    90,
      94,    96,   100,   101,   110,   111,   120,   124,   128,   130,
     132,   135,   137,   139,   141,   143,   145,   147,   148,   149,
     150,   152,   154,   162,   172,   182,   192,   193,   200,   206,
     216,   217,   230,   242,   261,   280,   284,   286,   288,   292,
     294,   296,   297,   298,   299,   303,   304,   308,   310,   311
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      45,     0,    -1,    68,    46,    78,    -1,    46,    47,    50,
      -1,    47,    50,    -1,    -1,    18,    52,    -1,    32,    -1,
      -1,    65,    48,    79,    -1,    -1,    66,    49,    79,    -1,
      69,    70,    71,    -1,    81,    -1,    33,    -1,    34,    -1,
       4,    -1,     3,    -1,    27,    -1,    26,    -1,    -1,    35,
      -1,    -1,    36,    -1,    -1,    37,    -1,    -1,    57,    -1,
      51,    -1,     9,    -1,    12,    -1,    51,    -1,     9,    -1,
      10,    -1,    11,    -1,    51,    53,    51,    -1,     9,    53,
       9,    -1,    10,    53,    10,    -1,    11,    53,    11,    -1,
      25,    38,     3,    -1,    13,    -1,    61,    53,    61,    -1,
      -1,     6,     7,     8,    63,    53,     3,    10,    11,    -1,
      -1,     3,    10,    11,    64,    53,     3,    10,    11,    -1,
      51,    53,    51,    -1,     9,    53,     9,    -1,    24,    -1,
      28,    -1,    21,    67,    -1,    15,    -1,    23,    -1,    22,
      -1,    19,    -1,    15,    -1,    23,    -1,    -1,    -1,    -1,
      39,    -1,    40,    -1,    17,    54,    62,    53,    58,    55,
      83,    -1,    20,    54,    62,    53,    59,    53,    56,    55,
      83,    -1,    16,    54,    62,    53,    59,    53,    56,    55,
      83,    -1,    31,    54,    62,    53,    59,    53,    56,    55,
      83,    -1,    -1,    30,    72,    54,    74,    55,    83,    -1,
      29,    54,    62,    55,    83,    -1,    14,    54,    62,    53,
      58,    53,    58,    55,    83,    -1,    -1,    14,    54,    62,
      53,    58,    53,    58,    53,    73,    76,    55,    83,    -1,
      14,    54,    62,    53,    58,    53,    58,    53,    60,    55,
      83,    -1,    20,    54,    62,    53,    59,    53,    56,    55,
      41,    42,    20,    54,    62,    53,    59,    53,    56,    55,
      -1,    16,    54,    62,    53,    59,    53,    56,    55,    41,
      42,    16,    54,    62,    53,    59,    53,    56,    55,    -1,
      74,    53,    75,    -1,    75,    -1,    62,    -1,    76,    53,
      77,    -1,    77,    -1,    58,    -1,    -1,    -1,    -1,    43,
      80,     5,    -1,    -1,    43,    82,     5,    -1,    78,    -1,
      -1,    43,    84,     5,    78,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   120,   120,   123,   124,   127,   128,   129,   130,   130,
     131,   131,   132,   133,   136,   137,   140,   141,   144,   145,
     148,   149,   152,   153,   156,   157,   160,   161,   164,   165,
     166,   169,   170,   171,   172,   175,   182,   189,   196,   205,
     208,   211,   225,   225,   235,   235,   246,   253,   263,   264,
     267,   268,   269,   270,   271,   274,   275,   278,   289,   298,
     299,   300,   303,   307,   322,   336,   340,   340,   344,   348,
     351,   351,   359,   363,   370,   378,   379,   382,   385,   386,
     389,   393,   416,   417,   417,   420,   420,   423,   424,   424
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INT", "REAL", "STRING", "HOUR", "MINUTE", 
  "SECOND", "DEGREE", "ARCMINUTE", "ARCSECOND", "RADIAN", "SEXSTR", 
  "ANNULUS_", "B1950_", "BOX_", "CIRCLE_", "DEBUG_", "ECLIPTIC_", 
  "ELLIPSE_", "EQUATORIAL_", "GALACTIC_", "J2000_", "LOGICAL_", "N_", 
  "OFF_", "ON_", "PHYSICAL_", "POINT_", "POLYGON_", "ROTBOX_", "VERSION_", 
  "'\\n'", "';'", "','", "'('", "')'", "'='", "'+'", "'-'", "'&'", "'!'", 
  "'#'", "$accept", "start", "commands", "command", "@1", "@2", 
  "terminator", "numeric", "debug", "sp", "bp", "ep", "optangle", "angle", 
  "value", "vvalue", "numberof", "sexagesimal", "coord", "@3", "@4", 
  "coordSystem", "skyFrame", "equatorial", "initGlobal", "initLocal", 
  "include", "shape", "@5", "@6", "polyNodes", "polyNode", "aRads", 
  "aRad", "processAnnulus", "comment", "@7", "generalComment", "@8", 
  "shapeComment", "@9", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    10,    59,    44,    40,    41,    61,    43,
      45,    38,    33,    35
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    44,    45,    46,    46,    47,    47,    47,    48,    47,
      49,    47,    47,    47,    50,    50,    51,    51,    52,    52,
      53,    53,    54,    54,    55,    55,    56,    56,    57,    57,
      57,    58,    58,    58,    58,    59,    59,    59,    59,    60,
      61,    62,    63,    62,    64,    62,    62,    62,    65,    65,
      66,    66,    66,    66,    66,    67,    67,    68,    69,    70,
      70,    70,    71,    71,    71,    71,    72,    71,    71,    71,
      73,    71,    71,    71,    71,    74,    74,    75,    76,    76,
      77,    78,    79,    80,    79,    82,    81,    83,    84,    83
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     3,     3,     2,     0,     2,     1,     0,     3,
       0,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     0,     1,     0,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       1,     3,     0,     8,     0,     8,     3,     3,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     0,     0,     0,
       1,     1,     7,     9,     9,     9,     0,     6,     5,     9,
       0,    12,    11,    18,    18,     3,     1,     1,     3,     1,
       1,     0,     0,     0,     3,     0,     3,     1,     0,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
      57,     0,    58,     1,    51,     0,    54,     0,    53,    52,
      48,    49,     7,    85,    58,     0,     8,    10,    59,    13,
      19,    18,     6,    55,    56,    50,     0,     0,     2,    14,
      15,     4,    82,    82,    60,    61,     0,    86,     3,    83,
       9,    11,    22,    22,    22,    22,    22,    66,    22,    12,
       0,    23,     0,     0,     0,     0,     0,    22,     0,    84,
      17,    16,     0,    20,    40,    20,    20,    20,    20,    20,
      20,    24,     0,    20,     0,     0,    21,     0,     0,     0,
       0,     0,     0,     0,    25,    81,    77,    20,    76,     0,
      44,    42,    47,    17,    46,    41,    32,    33,    34,    31,
      20,    20,    20,    20,    20,    20,    24,    20,    88,    87,
      68,     0,    81,    20,    20,    20,     0,     0,     0,     0,
       0,    26,    81,    26,     0,    75,    67,    26,     0,     0,
      20,    36,    37,    38,    35,    29,    30,    28,    24,    27,
      62,    24,    81,    24,     0,     0,    70,    81,    81,    81,
      89,    81,     0,     0,     0,    24,     0,    69,     0,    64,
       0,    63,    65,    45,    43,     0,    81,    80,    20,    79,
       0,     0,    39,    72,     0,    81,    22,    22,    78,    71,
       0,     0,    20,    20,     0,     0,    20,    20,    26,    26,
      24,    24,    74,    73
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,    14,    15,    32,    33,    31,    65,    22,    77,
      52,    85,   138,   139,   167,   105,   155,    66,    86,   115,
     114,    16,    17,    25,     2,    18,    36,    49,    57,   156,
      87,    88,   168,   169,   109,    40,    50,    19,    26,   110,
     124
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -112
static const short yypact[] =
{
    -112,     6,   185,  -112,  -112,    -8,  -112,     5,  -112,  -112,
    -112,  -112,  -112,  -112,   159,    -3,  -112,  -112,     1,  -112,
    -112,  -112,  -112,  -112,  -112,  -112,    39,    -3,  -112,  -112,
    -112,  -112,    25,    25,  -112,  -112,    18,  -112,  -112,  -112,
    -112,  -112,    40,    40,    40,    40,    40,  -112,    40,  -112,
      70,  -112,    33,    33,    33,    33,    33,    40,    33,  -112,
      69,  -112,    76,    55,  -112,    55,    55,    55,    55,    55,
      55,    48,    33,    55,    84,    88,  -112,    93,    50,    90,
     106,   116,   106,   116,  -112,    63,  -112,    54,  -112,   116,
    -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,
      55,    55,    55,    55,    55,    55,    48,    55,  -112,  -112,
    -112,    33,    63,    55,    55,    55,   106,   103,   104,   107,
      50,    89,    63,    89,   117,  -112,  -112,    89,   118,   120,
      54,  -112,  -112,  -112,  -112,  -112,  -112,  -112,    48,  -112,
    -112,    48,  -112,    48,   121,   131,   105,    63,     9,    31,
    -112,    63,   133,   135,   109,    48,   106,  -112,   110,  -112,
     111,  -112,  -112,  -112,  -112,   146,    63,  -112,    54,  -112,
     138,   136,  -112,  -112,   106,    63,    40,    40,  -112,  -112,
      33,    33,    55,    55,   116,   116,    55,    55,    89,    89,
      48,    48,  -112,  -112
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -112,  -112,  -112,   137,  -112,  -112,   128,   -16,  -112,   -44,
     -43,     7,  -111,  -112,   -65,   -56,  -112,    78,   -45,  -112,
    -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,
    -112,    49,  -112,   -13,   -10,   130,  -112,  -112,  -112,   -67,
    -112
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -82
static const short yytable[] =
{
      53,    54,    55,    56,    28,    58,     3,    67,    68,    69,
      70,    71,   141,    73,    72,   100,   143,   106,    20,    21,
      23,    78,    79,    80,    81,    82,    83,   107,    24,    89,
      29,    30,    42,   113,    43,    44,    60,    61,    45,    62,
      34,    35,    63,   111,    37,   126,    64,    46,    47,    48,
     158,   130,   108,    93,    61,   140,   116,   117,   118,   119,
     120,   121,    94,   123,    99,   104,    99,   104,    39,   127,
     128,   129,   160,   104,   108,    59,    51,   190,   191,    74,
     157,   159,   161,    75,   162,    84,   146,   -24,   -24,    76,
      76,    84,    93,    61,   112,    90,    91,   -24,   135,   173,
      99,   136,    92,    64,   134,   137,   108,   137,   179,    93,
      61,   137,   131,   122,   132,    96,    97,    98,   133,    93,
      61,   144,   142,   145,   174,   101,   102,   103,   186,   187,
     154,   152,   150,   180,   181,   182,   183,   147,   184,   185,
      99,   153,   188,   189,   163,   148,   164,   165,   149,   172,
     151,    27,   170,   171,   176,    38,   177,    95,    99,   -81,
     125,   178,   166,    41,     0,     0,     0,     0,   104,   104,
       0,     0,   137,   137,     4,   175,     0,     5,     6,     0,
       7,     8,     9,    10,     0,     0,     0,    11,     0,     0,
       0,    12,    -5,    -5,     0,     0,     0,   192,   193,     0,
       4,     0,    13,     5,     6,     0,     7,     8,     9,    10,
       0,     0,     0,    11,     0,     0,     0,    12,    -5,    -5,
       0,     0,     0,     0,     0,     0,     0,     0,    13
};

static const short yycheck[] =
{
      43,    44,    45,    46,    14,    48,     0,    52,    53,    54,
      55,    56,   123,    58,    57,    80,   127,    82,    26,    27,
      15,    65,    66,    67,    68,    69,    70,    83,    23,    73,
      33,    34,    14,    89,    16,    17,     3,     4,    20,     6,
      39,    40,     9,    87,     5,   112,    13,    29,    30,    31,
      41,   116,    43,     3,     4,   122,   100,   101,   102,   103,
     104,   105,    78,   107,    80,    81,    82,    83,    43,   113,
     114,   115,    41,    89,    43,     5,    36,   188,   189,    10,
     147,   148,   149,     7,   151,    37,   130,    33,    34,    35,
      35,    37,     3,     4,    87,    11,     8,    43,     9,   166,
     116,    12,     9,    13,   120,   121,    43,   123,   175,     3,
       4,   127,     9,   106,    10,     9,    10,    11,    11,     3,
       4,     3,     5,     3,   168,     9,    10,    11,   184,   185,
      25,    10,   142,   176,   177,   180,   181,   130,   182,   183,
     156,    10,   186,   187,    11,   138,    11,    38,   141,     3,
     143,    14,    42,    42,    16,    27,    20,    79,   174,     0,
     111,   174,   155,    33,    -1,    -1,    -1,    -1,   184,   185,
      -1,    -1,   188,   189,    15,   168,    -1,    18,    19,    -1,
      21,    22,    23,    24,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    32,    33,    34,    -1,    -1,    -1,   190,   191,    -1,
      15,    -1,    43,    18,    19,    -1,    21,    22,    23,    24,
      -1,    -1,    -1,    28,    -1,    -1,    -1,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    45,    68,     0,    15,    18,    19,    21,    22,    23,
      24,    28,    32,    43,    46,    47,    65,    66,    69,    81,
      26,    27,    52,    15,    23,    67,    82,    47,    78,    33,
      34,    50,    48,    49,    39,    40,    70,     5,    50,    43,
      79,    79,    14,    16,    17,    20,    29,    30,    31,    71,
      80,    36,    54,    54,    54,    54,    54,    72,    54,     5,
       3,     4,     6,     9,    13,    51,    61,    62,    62,    62,
      62,    62,    54,    62,    10,     7,    35,    53,    53,    53,
      53,    53,    53,    53,    37,    55,    62,    74,    75,    53,
      11,     8,     9,     3,    51,    61,     9,    10,    11,    51,
      58,     9,    10,    11,    51,    59,    58,    59,    43,    78,
      83,    53,    55,    59,    64,    63,    53,    53,    53,    53,
      53,    53,    55,    53,    84,    75,    83,    53,    53,    53,
      58,     9,    10,    11,    51,     9,    12,    51,    56,    57,
      83,    56,     5,    56,     3,     3,    53,    55,    55,    55,
      78,    55,    10,    10,    25,    60,    73,    83,    41,    83,
      41,    83,    83,    11,    11,    38,    55,    58,    76,    77,
      42,    42,     3,    83,    53,    55,    16,    20,    77,    83,
      54,    54,    62,    62,    53,    53,    59,    59,    53,    53,
      56,    56,    55,    55
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
#line 129 "prosparser.Y"
    {cerr << "PROS" << endl;;}
    break;

  case 8:
#line 130 "prosparser.Y"
    {globalSystem = (CoordSystem)yyvsp[0].integer;;}
    break;

  case 10:
#line 131 "prosparser.Y"
    {globalSystem = WCS; globalSky = (SkyFrame)yyvsp[0].integer;;}
    break;

  case 16:
#line 140 "prosparser.Y"
    {yyval.real=yyvsp[0].real;;}
    break;

  case 17:
#line 141 "prosparser.Y"
    {yyval.real=yyvsp[0].integer;;}
    break;

  case 18:
#line 144 "prosparser.Y"
    {yydebug=1;;}
    break;

  case 19:
#line 145 "prosparser.Y"
    {yydebug=0;;}
    break;

  case 26:
#line 160 "prosparser.Y"
    {yyval.real = 0;;}
    break;

  case 27:
#line 161 "prosparser.Y"
    {yyval.real = yyvsp[0].real;;}
    break;

  case 28:
#line 164 "prosparser.Y"
    {yyval.real = degToRad(yyvsp[0].real);;}
    break;

  case 29:
#line 165 "prosparser.Y"
    {yyval.real = degToRad(yyvsp[0].real);;}
    break;

  case 30:
#line 166 "prosparser.Y"
    {yyval.real=yyvsp[0].real;;}
    break;

  case 31:
#line 169 "prosparser.Y"
    {yyval.real = FITPTR->mapLenToRef(yyvsp[0].real, IMAGE);;}
    break;

  case 32:
#line 170 "prosparser.Y"
    {yyval.real = FITPTR->mapLenToRef(yyvsp[0].real, checkWCSSystem(), DEGREES);;}
    break;

  case 33:
#line 171 "prosparser.Y"
    {yyval.real = FITPTR->mapLenToRef(yyvsp[0].real, checkWCSSystem(), ARCMIN);;}
    break;

  case 34:
#line 172 "prosparser.Y"
    {yyval.real = FITPTR->mapLenToRef(yyvsp[0].real, checkWCSSystem(), ARCSEC);;}
    break;

  case 35:
#line 176 "prosparser.Y"
    {
	  Vector r = FITPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real), IMAGE);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 36:
#line 183 "prosparser.Y"
    {
	  Vector r=FITPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real),checkWCSSystem(),DEGREES);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 37:
#line 190 "prosparser.Y"
    {
	  Vector r=FITPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real),checkWCSSystem(),ARCMIN);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 38:
#line 197 "prosparser.Y"
    {
	  Vector r=FITPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real),checkWCSSystem(),ARCSEC);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 39:
#line 205 "prosparser.Y"
    {yyval.integer = yyvsp[0].integer;;}
    break;

  case 40:
#line 208 "prosparser.Y"
    {yyval.real = parseDMS(yyvsp[0].str);;}
    break;

  case 41:
#line 212 "prosparser.Y"
    {
	  Vector r;
	  CoordSystem sys = checkWCSSystem();
	  SkyFrame sky = checkWCSSky();
	  if (sky == GALACTIC || sky == ECLIPTIC) 
	    r = FITPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), sys, sky);
	  else
	    r = FITPTR->mapToRef(Vector(yyvsp[-2].real*360./24.,yyvsp[0].real), sys, sky);

	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 42:
#line 225 "prosparser.Y"
    {prossign2 = prossign;;}
    break;

  case 43:
#line 226 "prosparser.Y"
    {
	  Vector r = FITPTR->mapToRef(
	    Vector(hmsToDegree(prossign2,yyvsp[-7].integer,yyvsp[-6].integer,yyvsp[-5].real), 
	    dmsToDegree(prossign,yyvsp[-2].integer,yyvsp[-1].real,yyvsp[0].real)),
	    checkWCSSystem(), checkWCSSky());
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 44:
#line 235 "prosparser.Y"
    {prossign2 = prossign;;}
    break;

  case 45:
#line 237 "prosparser.Y"
    {
	  Vector r = FITPTR->mapToRef(
	    Vector(dmsToDegree(prossign2,yyvsp[-7].integer,yyvsp[-6].real,yyvsp[-5].real),
	    dmsToDegree(prossign,yyvsp[-2].integer,yyvsp[-1].real,yyvsp[0].real)),
	    checkWCSSystem(), checkWCSSky());
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 46:
#line 247 "prosparser.Y"
    {
	  Vector r = FITPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), localSystem, localSky);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 47:
#line 254 "prosparser.Y"
    {
	  Vector r = FITPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real),
	    checkWCSSystem(), checkWCSSky());
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 48:
#line 263 "prosparser.Y"
    {yyval.integer = IMAGE;;}
    break;

  case 49:
#line 264 "prosparser.Y"
    {yyval.integer = PHYSICAL;;}
    break;

  case 50:
#line 267 "prosparser.Y"
    {yyval.integer = yyvsp[0].integer;;}
    break;

  case 51:
#line 268 "prosparser.Y"
    {yyval.integer = FK4;;}
    break;

  case 52:
#line 269 "prosparser.Y"
    {yyval.integer = FK5;;}
    break;

  case 53:
#line 270 "prosparser.Y"
    {yyval.integer = GALACTIC;;}
    break;

  case 54:
#line 271 "prosparser.Y"
    {yyval.integer = ECLIPTIC;;}
    break;

  case 55:
#line 274 "prosparser.Y"
    {yyval.integer = FK4;;}
    break;

  case 56:
#line 275 "prosparser.Y"
    {yyval.integer = FK5;;}
    break;

  case 57:
#line 278 "prosparser.Y"
    {
	  // global properties
	  globalSystem = IMAGE;
	  globalSky = NATIVEWCS;
	  globalProps =
	    Marker::SELECT | Marker::EDIT | Marker::MOVE |
	    Marker::ROTATE | Marker::DELETE | Marker::HIGHLITE |
	    Marker::INCLUDE | Marker::SOURCE;
	;}
    break;

  case 58:
#line 289 "prosparser.Y"
    {
	  // global properties
	  localSystem = globalSystem;
	  localSky = globalSky;
	  localProps = globalProps;
	  strcpy(localComment,"");
	;}
    break;

  case 59:
#line 298 "prosparser.Y"
    {setProps(&localProps, Marker::INCLUDE, 1);;}
    break;

  case 60:
#line 299 "prosparser.Y"
    {setProps(&localProps, Marker::INCLUDE, 1);;}
    break;

  case 61:
#line 300 "prosparser.Y"
    {setProps(&localProps, Marker::INCLUDE, 0);;}
    break;

  case 62:
#line 304 "prosparser.Y"
    {FR->createCircleCmd(Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    color,1,font,text,localProps,localComment,taglist);;}
    break;

  case 63:
#line 308 "prosparser.Y"
    {
	  // for ellipse annulus
	  aStatus = 1;
	  aCenter = Vector(yyvsp[-6].vector);
	  aAngle = yyvsp[-2].real;
	  aVector[0] = Vector(yyvsp[-4].vector);
	  aNum = 1;
	  strncpy(aComment,localComment,80);
	  aProps = localProps;

	  FR->createEllipseCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	  color,1,font,text,localProps,localComment,taglist);
	;}
    break;

  case 64:
#line 323 "prosparser.Y"
    {
	  // for box annulus
	  aStatus = 3;
	  aCenter = Vector(yyvsp[-6].vector);
	  aAngle = yyvsp[-2].real;
	  aVector[0] = Vector(yyvsp[-4].vector);
	  aNum = 1;
	  strncpy(aComment,localComment,80);
	  aProps = localProps;

	  FR->createBoxCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    color,1,font,text,localProps,localComment,taglist);
	;}
    break;

  case 65:
#line 337 "prosparser.Y"
    {FR->createBoxCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    color,1,font,text,localProps,localComment,taglist);;}
    break;

  case 66:
#line 340 "prosparser.Y"
    {polylist.deleteAll();;}
    break;

  case 67:
#line 341 "prosparser.Y"
    {FR->createPolygonCmd(polylist,color,1,font,
	      text,localProps,localComment,taglist);;}
    break;

  case 68:
#line 345 "prosparser.Y"
    {FR->createBoxCirclePointCmd(Vector(yyvsp[-2].vector),
	    color,1,font,text,localProps,localComment,taglist);;}
    break;

  case 69:
#line 349 "prosparser.Y"
    {FR->createAnnulusCmd(Vector(yyvsp[-6].vector),yyvsp[-4].real,yyvsp[-2].real,1,
	    color,1,font,text,localProps,localComment,taglist);;}
    break;

  case 70:
#line 351 "prosparser.Y"
    {aNum=2;;}
    break;

  case 71:
#line 353 "prosparser.Y"
    {
	  aAnnuli[0] = yyvsp[-7].real;
	  aAnnuli[1] = yyvsp[-5].real;
	  FR->createAnnulusCmd(Vector(yyvsp[-9].vector),aAnnuli,aNum,
	  color,1,font,text,localProps,localComment,taglist);
	;}
    break;

  case 72:
#line 360 "prosparser.Y"
    {FR->createAnnulusCmd(Vector(yyvsp[-8].vector),yyvsp[-6].real,yyvsp[-4].real,yyvsp[-2].integer,
	    color,1,font,text,localProps,localComment,taglist);;}
    break;

  case 73:
#line 365 "prosparser.Y"
    {	
	  aStatus = 2;
	  aVector[aNum++] = Vector(yyvsp[-13].vector);
	;}
    break;

  case 74:
#line 372 "prosparser.Y"
    {	
	  aStatus = 4;
	  aVector[aNum++] = Vector(yyvsp[-13].vector);
	;}
    break;

  case 77:
#line 382 "prosparser.Y"
    {polylist.append(new Vertex(yyvsp[0].vector));;}
    break;

  case 80:
#line 389 "prosparser.Y"
    {aAnnuli[aNum++] = yyvsp[0].real;;}
    break;

  case 81:
#line 393 "prosparser.Y"
    {
	  switch (aStatus) {
	  case 0: // do nothing
	    break;
	  case 1: // we found just an ellipse, do nothing
	    break;
	  case 2: // ok we have an ellipse annulus
	    FR->markerDeleteLastCmd(); // delete the previous ellipse
	    FR->createEllipseAnnulusCmd(aCenter,aAngle,aNum,aVector,
	      color,1,font,text,aProps,aComment,taglist);
	    break;
	  case 3: // we found just a box, do nothing
	    break;
	  case 4: // ok, we have a box annulus
	    FR->markerDeleteLastCmd(); // delete the previous box
	    FR->createBoxAnnulusCmd(aCenter,aAngle,aNum,aVector,
	      color,1,font,text,aProps,aComment,taglist);
	    break;
	  }
	  aStatus = 0;
	;}
    break;

  case 83:
#line 417 "prosparser.Y"
    {DISCARD_(1);}
    break;

  case 85:
#line 420 "prosparser.Y"
    {DISCARD_(1);}
    break;

  case 88:
#line 424 "prosparser.Y"
    {DISCARD_(0);}
    break;

  case 89:
#line 425 "prosparser.Y"
    {strncpy(localComment,yyvsp[-1].str,80);;}
    break;


    }

/* Line 999 of yacc.c.  */
#line 1726 "prosparser.C"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 428 "prosparser.Y"


static void setProps(unsigned short* props, unsigned short prop, int value)
{
  if (value)
    *props |= prop;
  else
    *props &= ~prop;
}

static CoordSystem checkWCSSystem()
{
  switch (localSystem) {
  case IMAGE:
  case PHYSICAL:
    return WCS;
  default:
    return localSystem;
  }
}

static SkyFrame checkWCSSky()
{
  switch (localSystem) {
  case IMAGE:
  case PHYSICAL:
    return NATIVEWCS;
  default:
   return localSky;
  }
}

